#include <SDL.h>
#include <cstdio>

void bucle(SDL_Renderer *renderer, int retardo);

int main( int argc, char * argv[] ) {
    SDL_Window *ventana;
    SDL_Renderer *renderer;

    SDL_Init(SDL_INIT_EVERYTHING);
    ventana = SDL_CreateWindow(NULL, SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED,
            640, 480, SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS);
    renderer = SDL_CreateRenderer(ventana, -1, 0);

    bucle(renderer, 10);

    SDL_DestroyRenderer(renderer);
    SDL_DestroyWindow(ventana);
    SDL_Quit();
    return 0;
}

void bucle(SDL_Renderer *renderer, int retardo) {
    Uint64 tick, tick0;
    SDL_FRect rect = {320.0, 240.0, 20.0, 20.0};
    SDL_Event test_event;
    float velocidad = 200.0;
    float dirh;
    float dirv;
    bool salir = false;
    bool izq = false;
    bool der = false;
    bool arr = false;
    bool aba = false;

    tick0 = SDL_GetTicks64();
    do {
        while(SDL_PollEvent(&test_event)) {
            switch(test_event.type) {
            case SDL_KEYDOWN:
                if(test_event.key.keysym.sym == SDLK_LEFT)  { izq = true; }
                if(test_event.key.keysym.sym == SDLK_RIGHT) { der = true; }
                if(test_event.key.keysym.sym == SDLK_UP)    { arr = true; }
                if(test_event.key.keysym.sym == SDLK_DOWN)  { aba = true;  }
                if(test_event.key.keysym.sym == SDLK_ESCAPE) { salir = true; }
                break;
            case SDL_KEYUP:
                if(test_event.key.keysym.sym == SDLK_LEFT)  { izq = false; }
                if(test_event.key.keysym.sym == SDLK_RIGHT) { der = false; }
                if(test_event.key.keysym.sym == SDLK_UP)    { arr = false; }
                if(test_event.key.keysym.sym == SDLK_DOWN)  { aba = false; }
                break;
            }
        }
        dirh = 0.0;
        dirv = 0.0;
        if(izq && !der) dirh = -1.0;
        if(!izq && der) dirh = +1.0;
        if(arr && !aba) dirv = -1.0;
        if(!arr && aba) dirv = +1.0;
        tick = SDL_GetTicks64()-tick0;
        tick0 = SDL_GetTicks64();
        rect.x += dirh*(velocidad*(tick)/1000.0);
        rect.y += dirv*(velocidad*(tick)/1000.0);
        SDL_SetRenderDrawColor(renderer, 0,0,0,255);
        SDL_RenderClear(renderer);
        SDL_SetRenderDrawColor(renderer, 255,255,255,255);
        SDL_RenderDrawRectF(renderer, &rect);
        SDL_RenderPresent(renderer);
        SDL_Delay(retardo);
    } while(!salir);
}
